<template>
  <div v-if="user.isAdmin" class="template">
    <h1>Liste des comptes</h1>

    <div
      v-for="(accountUser, index) in accountUsers"
      :accountUser="accountUser"
      :key="index"
      class="accountPreview"
    >
      <div v-if="accountUser.urlImage" class="accountPreviewImgContainer">
        <img
          :src="accountUser.urlImage"
          class="accountImg"
          alt="image choisie par l'utilisateur pour illustrer son post"
        />
      </div>

      <div v-else class="accountPreviewImgContainer">
        <img
          src="../assets/images/user.png"
          alt="Icone d'utilisateur par défaut en l'absence de photo"
          class="accountImg"
        />
      </div>

      <div class="accountPreviewTextContainer">
        <p>{{ accountUser.firstName }} {{ accountUser.lastName }}</p>
        <button @click="deleteAdmin(accountUser.id)">Supprimer le compte</button>
        <font-awesome-icon icon="trash" @click="deleteAdmin(accountUser.id)" />
      </div>
    </div>
  </div>
</template>

<script>
import axios from "axios";
import { mapState } from "vuex";
import dayjs from "dayjs";
require("dayjs/locale/fr");
dayjs.locale("fr");

export default {
  name: "AccountAdminView",
  components: {},
  data() {
    return {
      accountUsers: [],
    };
  },
  computed: {
    ...mapState(["status", "user"]),
  },

  //Redirection vers login si non connecté
  mounted() {
    if (this.$store.state.user.userId == -1) {
      this.$router.push("/login");
      return;
    }
  },
  created() {
    const token = this.$store.state.user.token;

    axios
      .get("http://localhost:3000/api/users", {
        headers: {
          Authorization: `Basic ${token}`,
        },
      })
      .then((response) => {
        this.accountUsers = response.data;
      })
      .catch((error) => {
        console.log(error);
      });
  },
  methods: {
    deleteAdmin(id) {
      const token = this.$store.state.user.token;
      if (
        window.confirm(
          "Voulez-vous supprimez ce compte ? Cette opération est irreversible. Les posts et commentaires seront supprimés"
        )
      ) {
        axios
          .delete(`http://localhost:3000/api/users/delete/admin/${id}`, {
            headers: {
              Authorization: `Basic ${token}`,
            },
          })
          .then(({data}) => {
            console.log({data});
            this.accountUsers = data.users
            alert("Le compte a été supprimé.");
          })
          .catch((error) => {
            console.log(error);
          });
      }
    },
  },
  dateCreated(date) {
    return dayjs(date).format("dddd D MMMM YYYY", "fr");
  },
};
</script>

<style lang="scss" scoped>
font-awesome-icon {
  cursor: pointer;
}
.accountPreview {
  padding: 10px;
  margin: 20px;
  min-width: 900px;
  max-width: 1100px;
  min-height: 100px;
  max-height: 150px;
  background-color: rgb(255, 255, 255);
  color: rgba(0, 0, 0, 0.92);
  transition: box-shadow 300ms cubic-bezier(0.4, 0, 0.2, 1) 0ms;
  border-radius: 4px;
  box-shadow: rgb(0 0 0 / 20%) 0px 2px 1px -1px, rgb(0 0 0 / 14%) 0px 1px 1px 0px,
    rgb(0 0 0 / 12%) 0px 1px 3px 0px;

  &ImgContainer {
    width: 50px;
    height: auto;
  }
  &TextContainer {
    width: 75%;
  }
}
.accountImg {
  width: 100%;
  height: 100%;
  object-fit: cover;
}

button {
  border: none;
  border-radius: 10%;
  margin: 10px;
  cursor: pointer;
}
@media screen and (max-width: 660px) {
  .template {
    padding-top: 150px;
  }
  .container {
    flex-direction: column;
    min-width: 80%;
    max-width: 90%;
    min-height: 150px;
    &Element {
      &Img {
        width: 100%;
        height: 100%;
        object-fit: cover;
      }
      &1 {
        width: 100%;
      }
      &2 {
        width: 100%;
        padding: 10px;
      }
    }
  }
}
</style>
